﻿local RSwapper3 = RSwapper3_E1115F90_2428_4DA0_AA34_4CCFCC5BFA00;

RSwapper3.ENABLED = "|cff00ff00[" .. RSwapper3.Locale.Enabled .. "]|r";
RSwapper3.DISABLED = "|cffff0000[" .. RSwapper3.Locale.Disabled .. "]|r";
RSwapper3.ISFISHING = "|cff00ffff[" .. RSwapper3.Locale.Fishing .. "]|r";
RSwapper3.ISJOUSTING = "|cffabcffc[" .. (GetSpellInfo(45105)) .. "]|r";

local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
RSwapper3.DataObj = ldb:NewDataObject("RSwapper3", {type = "data source", icon = "Interface\\Icons\\Ability_Stealth", text = RSwapper3.DISABLED, label = "RSwapper3", tocname = "RSwapper3"});

local dataobj = RSwapper3.DataObj;

function dataobj:UpdateText()
    if (not RSwapper3.Vars.Enable) then
        dataobj.text = "|cffff0000[" .. RSwapper3.Locale.Disabled .. "]|r";
    elseif (RSwapper3.Mode == 1 and RSwapper3.Status == 0) then
        if (RSwapper3.Vars.StealthSet) then
            dataobj.text = format(RSwapper3.HAVEDAGGER_FMT, RSwapper3.Vars.StealthSet);
        else
            dataobj.text = format(RSwapper3.HAVEDAGGER_FMT, RSwapper3.Locale.NotSet);
        end
    elseif (RSwapper3.Mode == 2 and RSwapper3.Status == 0) then
        if (RSwapper3.Vars.CombatSet) then
            dataobj.text = format(RSwapper3.HAVESWORD_FMT, RSwapper3.Vars.CombatSet);
        else
            dataobj.text = format(RSwapper3.HAVESWORD_FMT, RSwapper3.Locale.NotSet);
        end
    elseif (RSwapper3.Mode == 1) then
        if (RSwapper3.Vars.StealthSet) then
            dataobj.text = format(RSwapper3.NEEDDAGGER_FMT, RSwapper3.Vars.StealthSet);
        else
            dataobj.text = format(RSwapper3.NEEDDAGGER_FMT, RSwapper3.Locale.NotSet);
        end
    elseif (RSwapper3.Mode == 2) then
        if (RSwapper3.Vars.CombatSet) then
            dataobj.text = format(RSwapper3.NEEDSWORD_FMT, RSwapper3.Vars.CombatSet);
        else
            dataobj.text = format(RSwapper3.NEEDSWORD_FMT, RSwapper3.Locale.NotSet);
        end
    elseif (RSwapper3.Mode == 3) then
        dataobj.text = RSwapper3.ISFISHING;
    elseif (RSwapper3.Mode == 4) then
        dataobj.text = RSwapper3.ISJOUSTING;
    else
        dataobj.text = "|cff00ff00[" .. RSwapper3.Locale.Enabled .. "]|r"; -- it's in some state, but enabled.
    end
end

function dataobj:OnTooltipShow()
    self:AddLine("RSwapper3");
    self:AddLine(" ");

    if (RSwapper3.NotRogue) then
        self:AddLine(RSwapper3.Locale.IsNotRogue);
        return;
    end

    if (not RSwapper3.Vars.Enable) then
        self:AddLine("|cffff0000" .. RSwapper3.Locale.Disabled .. "|r");
        return;
    end

    self:AddLine(dataobj.text);
    if (RSwapper3.Status == 1) then
        self:AddLine("|cffffff00" .. RSwapper3.Locale.Pending .. "|r");
    elseif (RSwapper3.Status == 2) then
        self:AddLine("|cffff0000" .. RSwapper3.Locale.NotSet .. "|r");
    elseif (RSwapper3.Status == 3) then
        self:AddLine("|cffff0000" .. RSwapper3.Locale.MissingPieces .. "|r");
    elseif (RSwapper3.Status == 4) then
        self:AddLine("|cffff0000" .. EQUIPMENT_MANAGER_IS_DISABLED .. "|r");
    end
end

function dataobj:OnEnter()
    GameTooltip:SetOwner(self, "ANCHOR_NONE");
    GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
    GameTooltip:ClearLines();
    dataobj.OnTooltipShow(GameTooltip);
    GameTooltip:Show();
end

function dataobj:OnLeave()
    GameTooltip:Hide();
end

function dataobj:OnClick(button)
    if (RSwapper3.NotRogue) then
        return;
    end
    GameTooltip:Hide();
    InterfaceOptionsFrame_OpenToCategory(RSwapper3.GUI.MainFrame);
end

