﻿local RSwapper3 = RSwapper3_E1115F90_2428_4DA0_AA34_4CCFCC5BFA00;

RSwapper3.GUI = {};
RSwapper3.GUI.MainFrame = CreateFrame("Frame", "RSwapper3Panel", UIParent);

local MainFrame = RSwapper3.GUI.MainFrame;

function MainFrame:EventHandler(event, ...)
    if (RSwapper3[event]) then
        RSwapper3[event](self, ...);
    end
end
MainFrame:SetScript("OnEvent", MainFrame.EventHandler);

function MainFrame:DoInit()
    local checkwidth = 26;

    MainFrame.name = "RSwapper3";
    MainFrame:SetScript("OnShow", MainFrame.ShowHandler);

    MainFrame.iddTitle = MainFrame:CreateFontString("$parent_Title","ARTWORK","GameFontNormalLarge");
    MainFrame.iddTitle:SetPoint("TOPLEFT", MainFrame, "TOPLEFT", 13, -13);
    MainFrame.iddTitle:SetText("RSwapper3 v" .. RSwapper3.RS3VERSION);
    MainFrame.iddTitle:SetJustifyH("CENTER");

    MainFrame.iddHelp = MainFrame:CreateFontString("$parent_Help","ARTWORK","GameFontNormal");
    MainFrame.iddHelp:SetPoint("TOPLEFT", MainFrame.iddTitle, "BOTTOMLEFT", 0, -8);
    MainFrame.iddHelp:SetText("|cffffffff    " .. RSwapper3.Locale.Help .. "|r");
    MainFrame.iddHelp:SetJustifyH("LEFT");
    MainFrame.iddHelp:SetJustifyV("TOP");

    MainFrame.iddEnableBtn = MainFrame:AddCheck(ENABLE, "$parent_EnableBtn", MainFrame.OnClickEnable,
        MainFrame.iddHelp, 0, -8, checkwidth);
    MainFrame.iddSoundBtn = MainFrame:AddCheck(ENABLE_SOUNDFX, "$parent_SoundBtn", MainFrame.OnClickSound,
        MainFrame.iddEnableBtn, 0, 0, checkwidth);

    MainFrame.iddStealthSet = MainFrame:CreateFontString("$parent_StealthSet","ARTWORK","GameFontNormal");
    MainFrame.iddStealthSet:SetText(" "); -- placeholder
    MainFrame.iddStealthSet:SetPoint("TOPLEFT", MainFrame.iddSoundBtn, "BOTTOMLEFT", 0, -8);
    MainFrame.iddStealthSet:SetJustifyH("LEFT");
    MainFrame.iddStealthSet:SetJustifyV("TOP");

    MainFrame.iddStealthSetBtn = CreateFrame("Button", "$parent_StealthSetBtn", MainFrame, "UIPanelButtonTemplate");
    MainFrame.iddStealthSetBtn:SetText("...");
    MainFrame.iddStealthSetBtn:SetWidth(MainFrame.iddStealthSetBtn:GetTextWidth() + 10);
    MainFrame.iddStealthSetBtn:SetPoint("TOPLEFT", MainFrame.iddStealthSet, "TOPRIGHT", 5, 0);
    MainFrame.iddStealthSetBtn:SetPoint("BOTTOM", MainFrame.iddStealthSet, "BOTTOM");
    MainFrame.iddStealthSetBtn:SetScript("OnClick", MainFrame.OnClickStealthSet);

    MainFrame.iddCombatSet = MainFrame:CreateFontString("$parent_CombatSet","ARTWORK","GameFontNormal");
    MainFrame.iddCombatSet:SetText(" "); -- placeholder    
    MainFrame.iddCombatSet:SetPoint("TOPLEFT", MainFrame.iddStealthSet, "BOTTOMLEFT", 0, -8);
    MainFrame.iddCombatSet:SetJustifyH("LEFT");
    MainFrame.iddCombatSet:SetJustifyV("TOP");

    MainFrame.iddCombatSetBtn = CreateFrame("Button", "$parent_CombatSetBtn", MainFrame, "UIPanelButtonTemplate");
    MainFrame.iddCombatSetBtn:SetText("...");
    MainFrame.iddCombatSetBtn:SetWidth(MainFrame.iddCombatSetBtn:GetTextWidth() + 10);
    MainFrame.iddCombatSetBtn:SetPoint("TOPLEFT", MainFrame.iddCombatSet, "TOPRIGHT", 5, 0);
    MainFrame.iddCombatSetBtn:SetPoint("BOTTOM", MainFrame.iddCombatSet, "BOTTOM");
    MainFrame.iddCombatSetBtn:SetScript("OnClick", MainFrame.OnClickCombatSet);

    MainFrame.iddStunsBtn = MainFrame:AddCheck(RSwapper3.Locale.Stuns, "$parent_StunsBtn", MainFrame.OnClickStuns,
        MainFrame.iddCombatSet, 0, 0, checkwidth);
    MainFrame.iddDanceBtn = MainFrame:AddCheck(RSwapper3.Locale.Dance, "$parent_DanceBtn", MainFrame.OnClickDance,
        MainFrame.iddStunsBtn, 0, 0, checkwidth);

    InterfaceOptions_AddCategory(MainFrame);
end

function MainFrame:AddCheck(text, name, func, anchor, xoff, yoff, width)
    local btnframe = CreateFrame("CheckButton", name, MainFrame, "UICheckButtonTemplate");
    btnframe:SetWidth(width);
    btnframe:SetHeight(width);
    btnframe:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", xoff, yoff);
    btnframe:SetScript("OnClick", func);

    btnframe.iddText = getglobal(btnframe:GetName() .. 'Text');
    btnframe.iddText:SetText(text);
    btnframe.iddText:SetJustifyH("LEFT");

    btnframe.iddClicker = CreateFrame("Button", name .. "Clicker", MainFrame);
    btnframe.iddClicker:SetAllPoints(btnframe.iddText);
    btnframe.iddClicker:SetScript("OnClick", func);
    btnframe.iddClicker:SetScript("OnEnter", function () btnframe:LockHighlight(); end);
    btnframe.iddClicker:SetScript("OnLeave", function () btnframe:UnlockHighlight(); end);
    return btnframe;
end

function MainFrame:Toggle()
    if InterfaceOptionsFrame:IsVisible() then
        InterfaceOptionsFrame:Hide();
    else
        InterfaceOptionsFrame_OpenToCategory(MainFrame);
    end
end

function MainFrame:ShowHandler(...)
    local maxwidth = MainFrame:GetWidth();
    if (maxwidth == 0) then maxwidth = 413; end

    MainFrame.iddTitle:SetWidth(maxwidth - 26);
    MainFrame.iddHelp:SetWidth(maxwidth - 26);

    MainFrame.iddEnableBtn.iddText:SetWidth(min(MainFrame.iddEnableBtn.iddText:GetStringWidth(),
        maxwidth - MainFrame.iddEnableBtn:GetWidth() - 26));
    MainFrame.iddSoundBtn.iddText:SetWidth(min(MainFrame.iddSoundBtn.iddText:GetStringWidth(),
        maxwidth - MainFrame.iddSoundBtn:GetWidth() - 26));
    MainFrame.iddStunsBtn.iddText:SetWidth(min(MainFrame.iddStunsBtn.iddText:GetStringWidth(),
        maxwidth - MainFrame.iddStunsBtn:GetWidth() - 26));
    MainFrame.iddDanceBtn.iddText:SetWidth(min(MainFrame.iddDanceBtn.iddText:GetStringWidth(),
        maxwidth - MainFrame.iddDanceBtn:GetWidth() - 26));
end

function MainFrame:refresh()
    local maxwidth = MainFrame:GetWidth();
    if (maxwidth == 0) then maxwidth = 413; end

    MainFrame.iddEnableBtn:SetChecked(RSwapper3.Vars.Enable);
    MainFrame.iddSoundBtn:SetChecked(RSwapper3.Vars.Sound);

    if (RSwapper3.Vars.StealthSet) then
        MainFrame.iddStealthSet:SetText(RSwapper3.Locale.StealthSet .. ": |cffffffff" .. RSwapper3.Vars.StealthSet .. "|r")
    else
        MainFrame.iddStealthSet:SetText(RSwapper3.Locale.StealthSet .. ": |cffff0000" .. RSwapper3.Locale.NotSet .. "|r")
    end
    if (RSwapper3.Vars.CombatSet) then
        MainFrame.iddCombatSet:SetText(RSwapper3.Locale.CombatSet .. ": |cffffffff" .. RSwapper3.Vars.CombatSet .. "|r")
    else
        MainFrame.iddCombatSet:SetText(RSwapper3.Locale.CombatSet .. ": |cffff0000" .. RSwapper3.Locale.NotSet .. "|r")
    end

    MainFrame.iddStealthSet:SetWidth(min(MainFrame.iddStealthSet:GetStringWidth(),
        maxwidth - MainFrame.iddStealthSetBtn:GetWidth() - 31));
    MainFrame.iddCombatSet:SetWidth(min(MainFrame.iddCombatSet:GetStringWidth(),
        maxwidth - MainFrame.iddCombatSetBtn:GetWidth() - 31));

    MainFrame.iddStunsBtn:SetChecked(RSwapper3.Vars.Stuns);
    MainFrame.iddDanceBtn:SetChecked(RSwapper3.Vars.Dance);
end

function MainFrame:OnClickEnable(button)
    if (button == "LeftButton") then
        RSwapper3:SetEnable();
        MainFrame.iddEnableBtn:SetChecked(RSwapper3.Vars.Enable);
    end
end

function MainFrame:OnClickSound(button)
    if (button == "LeftButton") then
        RSwapper3:SetSound();
        MainFrame.iddSoundBtn:SetChecked(RSwapper3.Vars.Sound);
    end
end

function MainFrame:OnClickStealthSet()
    MainFrame.SetMenu.Var = "StealthSet";
    ToggleDropDownMenu(1, nil, MainFrame.SetMenu, self, 0, 0);
end

function MainFrame:OnClickCombatSet()
    MainFrame.SetMenu.Var = "CombatSet";
    ToggleDropDownMenu(1, nil, MainFrame.SetMenu, self, 0, 0);
end

function MainFrame:OnClickStuns(button)
    if (button == "LeftButton") then
        RSwapper3.Vars.Stuns = not RSwapper3.Vars.Stuns;
        MainFrame.iddStunsBtn:SetChecked(RSwapper3.Vars.Stuns);
    end
end

function MainFrame:OnClickDance(button)
    if (button == "LeftButton") then
        RSwapper3.Vars.Dance = not RSwapper3.Vars.Dance;
        MainFrame.iddDanceBtn:SetChecked(RSwapper3.Vars.Dance);
    end
end

local menuitem = {};

MainFrame.SetMenu = CreateFrame("Frame", "RSwapper3SetMenu");
MainFrame.SetMenu.displayMode = "MENU";

function MainFrame.SetMenu:ClearSet()
    RSwapper3.Vars[MainFrame.SetMenu.Var] = nil;
    MainFrame:refresh();
end

function MainFrame.SetMenu:initialize(level)
    if (not level) then
        return;
    end

    if (level == 1) then
        menuitem.notCheckable = 1;
        menuitem.text = RSwapper3.Locale.NotSet;
        menuitem.func = MainFrame.SetMenu.ClearSet;
        UIDropDownMenu_AddButton(menuitem, level);

        for i = 1, GetNumEquipmentSets() do
            local name = GetEquipmentSetInfo(i);
            if (name) then
                menuitem.text = name;
                menuitem.func = function()
                        RSwapper3.Vars[MainFrame.SetMenu.Var] = name;
                        MainFrame:refresh();
                    end;
                UIDropDownMenu_AddButton(menuitem, level);
            end
        end
    end
end

